with Linda; use Linda;

package Matrix is

    type Vector_Type is array (1..3) of integer;
    function "*" (Left, Right: Vector_Type) return integer;

    type Matrix_Type is array (1..3) of Vector_Type;
    function "*" (Left, Right: Matrix_Type) return Matrix_Type;
    procedure Transpose (A: in Matrix_Type; B: out Matrix_Type);
    procedure print (M: Matrix_Type);

private 

    type Vector_Parameter_Type
    is   new Parameter_Type
         with record
             V: Vector_Type;
         end record;

    function "=" (Left, Right: Vector_Parameter_Type) return boolean;

end Matrix;