package body Lists
is
    function First (List: List_Type) return List_Iterator is
    begin
        return (List.List, List.List.First);
    end First;

    function Succ (Iterator: List_Iterator) return List_Iterator is
    begin
        return (Iterator.List, Iterator.Current.Next);
    end Succ;

    function Value (Iterator: List_Iterator) return Item_Type is
    begin
        return Iterator.Current.Item;
    end Value;

    function  End_Of_List (Iterator: List_Iterator) return boolean is
    begin
        return Iterator.Current = null;
    end;

    procedure Insert_First (List: List_Type; Item: Item_Type) is
    begin
        List.List.First := new Item_Record'(Item, List.List.First);
    end Insert_First;

    procedure Delete_First (List: List_Type) is
    begin
        List.List.First := List.List.First.Next;
    end Delete_First;

end Lists;